routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/prueba',function(){
	return view('user.home');
}); 

Route::get('/usuario',function(){
	return view('user.pages.user.show');
}); 
Route::get('/centro',function(){
	return view('user.pages.production.show');
}); 

Route::get('/editarc',function(){
	return view('user.pages.production.edit');
}); 

Route::get('/fc',function(){
	return view('user.pages.finance.create');
}); 

Route::get('/fe',function(){
	return view('user.pages.finance.edit');
}); 

Route::get('/fi',function(){
	return view('user.pages.finance.index');
}); 

Route::get('/fsm',function(){
	return view('user.pages.finance.showmonth');
}); 
Route::get('/fsy',function(){
	return view('user.pages.finance.showyear');
}); 


Route::get('/tc',function(){
	return view('user.pages.technical.create');
}); 

Route::get('/te',function(){
	return view('user.pages.technical.edit');
}); 

Route::get('/ti',function(){
	return view('user.pages.technical.index');
}); 

Route::get('/ts',function(){
	return view('user.pages.technical.show');
}); 





Route::get('/',function(){
	return view('auth.login');
}); 

Auth::routes(['verify'=>true]);

Route::group(['middleware'=>['auth','user:Encargado-Administrador'],'as' => 'user.'], function(){
	Route::get('/','HomeController@user_index')->name('inicio');

	Route::resource('responsable/finance','Responsable\FinanceController');
	Route::resource('responsable/production','Responsable\ProductionController');
	Route::resource('responsable/user','Responsable\UserController');
	Route::resource('responsable/technical','Responsable\TechnicalController');
	Route::post('responsable/upload_excel','Responsable\FinanceController@upload_excel')->name('finance.upload_excel');
	Route::post('responsable/technical/{technical}','Responsable\TechnicalconditionController@store')->name('technicalcondition.store');



});


Route::group(['middleware' => ['auth','user:Administrador'], 'as' => 'admin.'], function(){
	Route::get('/home','HomeController@index')->name('home');

	//Producione
	Route::resource('production','ProductionController');
	Route::get('production/{production}/update_all','ProductionController@update_all')->name('production.update_all');
	//Finance
	Route::get('finance/{production}/show_detail','FinanceController@show_detail')->name('finance.show_detail');
	Route::post('finance/upload_excel','FinanceController@upload_excel')->name('finance.upload_excel');
	Route::resource('finance','FinanceController');


	Route::resource('technical','TechnicalController');
	Route::get('technical/{technical}/downloadPDF','TechnicalController@downloadPDF')->name('technical.downloadPDF');

	Route::resource('technicalcondition','TechnicalconditionController');
	Route::post('technical/{technical}','TechnicalconditionController@store')->name('technicalcondition.store');


	Route::resource('event','EventController');
	//Period
	Route::resource('period','PeriodController');
	//user
	Route::resource('user','UserController');
	Route::get('user/{user}/assign_role','UserController@assign_role')->name('user.assign_role');
	Route::post('user/{user}/role_assignment','UserController@role_assignment')->name('user.role_assignment');
	Route::get('user/{user}/assign_permission','UserController@assign_permission')->name('user.assign_permission');
	Route::post('user/{user}/permission_assignment','UserController@permission_assignment')->name('user.permission_assignment');
	Route::post('user/{user}/update_all','UserController@update_all')->name('user.update_all');


	Route::resource('role','RoleController'); 
	Route::resource('permission','PermissionController');
});



Route::get('/clear-cache', function() {
    Artisan::call('cache:clear');
    Artisan::call('config:cache');
    return "Cache is cleared";
});

app/Production.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Storage;

class Production extends Model
{
    protected $fillable = [
        'code','name','src','description','email','phone',
    ];
    //Relaciones
    public function events(){
        return $this->belongsToMany('App\Event')->withTimestamps();
    }
    public function users()
    {
        return $this->hasMany('App\User');
    }
    public function technicals(){
        return $this->hasMany('App\Technical');
    }
    public function finances()
    {
        return $this->hasMany('App\Finance');
    }




    //Almacenamiento 
    public function store($request)
    {
        $production= Production::create($request->all());
        if($request->hasFile('src'))
        {
            $ruta=($request->file('src')->store('production','public'));
            $production->update(['src' => $ruta]);
        }

        alert('Exito','Centro de Production se ha guardado','success')->showConfirmButton();
        return $production;
    }
    public function my_update($request)
    {
        $production=User::findOrFail($request);
        $ruta= $this->src;
        if ($request->hasFile('src')) 
        {
            if ($this->src) 
            {
                Storage::delete('public/'.$this->src);
            }
                
            $ruta=$request->file('src')->store('production','public');
        }
   
        $production= Production::update([
            'name' => $request['name'],
            'code' => $request['code'],
            'src' => $ruta,
            'description' => $request['description'],
            'email' => $request['email'],
            'phone' => $request['phone'],
        
        ]);

        alert('Exito','Centro de Production se ha actualizado','success')->showConfirmButton();
        return $production;
    }
    //Validaciones

    public function has_event($id)
    {    
        foreach ($this->events as $event) {
            if($event->id == $id) return true;

        }
        return false;
    }

    public function is_active($production){
            if ($production->status==1) return true;
    }

    //Recuperación de información

    //Otras operaciones

    public static function production_month_total($production_id)
    {
        $period = Period::current_period();
        $filtrar=['period_id'=>$period->id,'production_id'=>$production_id];
        $total = Finance::where($filtrar)->sum('quantity');
        return $total;

    }

    public function has_finance_inPeriod($id)
    {

        foreach ($this->finances as $finance) {
            if($finance->production->id == $id && $finance->period->status==1) return true;

        }
        return false;
    }



    // Query Scope

    public function scopeStatus($query,$status){
      if($status)
        return $query->where('status',$status);
    }

}

app/Http/Controllers/ProductionController.php
<?php

namespace App\Http\Controllers;

use App\Production;
use App\User;
use Auth;
use App\Http\Requests\Production\UpdateRequest;
use Illuminate\Http\Request;
use App\Http\Requests\Production\StoreRequest;
class ProductionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.pages.production.index',[
            'productions' => Production::orderBy('id','DESC')->paginate(),
            
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.pages.production.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreRequest $request,Production $production)
    {
        $production = $production->store($request);
        return redirect()->route('admin.production.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Production  $production
     * @return \Illuminate\Http\Response
     */
    public function show(Production $production)
    {

        return view('admin.pages.production.show',[
            'production' => $production,
            'users' => $production->users,
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Production  $production
     * @return \Illuminate\Http\Response
     */
    public function edit(Production $production)
    {
        return view('admin.pages.production.edit',[
            'production' => $production,
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Production  $production
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateRequest $request, Production $production)
    {
        
        $production->my_update($request);
        return redirect()->route('admin.production.show',$production);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Production  $production
     * @return \Illuminate\Http\Response
     */
    public function destroy(Production $production)
    {   
        
        $user = User::where('production_id',$production->id)->update(['status'=>0]);
        Production::where('id',$production->id)->update(['status'=>0]);
        return redirect()->route('admin.production.show',$production);
    }

    public function update_all(Production $production)
    {
        
        $delete_user = User::where('production_id',$production->id)->update(['status'=>1]);
        Production::where('id',$production->id)->update(['status'=>1]);



        return redirect()->route('admin.production.show',$production);
    }



}

app/Http/Controllers/Responsable/ProductionController.php
<?php

namespace App\Http\Controllers\Responsable;

use App\Production;
use App\User;
use Auth;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;


class ProductionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/admin/pages/production/create.blade.php
@extends('admin.layouts.app')

@section('title','Crear Centro de Producción')

@section('header')


@endsection
@section('production')
active
@endsection
@section('content')


<section id="main-content">
	<section class="wrapper site-min-height">
		<div class="col-lg-12 mt">
            <div class="row content-panel">
              <div class="panel-heading w-100">
                <ul class="nav nav-tabs ">

                  <li class="">
                    <h4 >Registro de  Centro de producciones<h4/>
                  </li>
                </ul>
              </div>
              <!-- /panel-heading -->
              <div class="panel-body w-100">

                  <div id="registrar" class="">
                    <div class="col-12">
                        <form role="form"  class="form-horizontal" method="POST" action="{{ route('admin.production.store') }}" enctype="multipart/form-data">
                        	@csrf

                        	<div class="col-lg-6 col-md-12  ">


	                          <div class="form-group">
	                            <label class="col-12"> Nombre</label>
	                            <div class="col-12">
	                              	<input id="name" type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ old('name') }}" required autocomplete="name" autofocus>

	                                @error('name')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>

	                          <div class="form-group">
	                            <label class="col-12"> Código</label>
	                            <div class="col-12">
	                              	<input id="code" type="text" class="form-control @error('code') is-invalid @enderror" name="code" value="{{ old('code') }}" required autocomplete="code" autofocus>

	                                @error('code')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>

	                          <div class="form-group">
	                            <label class="col-12">Descripción</label>
	                            <div class="col-12">
	                              	<input id="description" type="text" class="form-control @error('description') is-invalid @enderror" name="description" value="{{ old('description') }}" required autocomplete="description" autofocus>

	                                @error('description')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>
	                          <div class="form-group">
	                            <label class="col-12"> Correo</label>
	                            <div class="col-12">
	                              	<input id="email" type="email" class="form-control @error('email') is-invalid @enderror" name="email" value="{{ old('email') }}" required autocomplete="email">

	                                @error('email')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>
	                          <div class="form-group">
	                            <label class="col-12">Teléfono</label>
	                            <div class="col-12">
	                              	<input id="phone" type="number" class="form-control @error('phone') is-invalid @enderror" name="phone" value="{{ old('phone') }}" required autocomplete="phone" autofocus>

	                                @error('phone')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>
	                          
	                          <div class="form-group">
	                            <label class="col-12">Estado</label>
	                            <div class="col-12">
	                              
	                              	<select name="status" class="form-control @error('status') is-invalid @enderror" required>
										
										<option value="1"> Activo</option>
								 		<option value="2"> Bloqueado</option>
										<option value="0"> Eliminado</option>

									</select>

	                                @error('status')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>
	                          
	                          
	                        </div>
	                        <div class="col-lg-6 col-md-12  ">
	                        	

	                        	<div class="form-group ">

				                  <div class="col-12 text-center">
				                    <div class="fileupload fileupload-new " data-provides="fileupload">
				                      <div class="col-12 row justify-content-center">
				                      	<span class="btn btn-theme btn-file w-100 my-3">
				                         
				                        <input id="src" type="file" class="default @error('src') is-invalid @enderror" name="src" placeholder="" accept="image/png, image/jpeg" autofocus>

			                                @error('src')
			                                    <span class="invalid-feedback" role="alert">
			                                        <strong>{{ $message }}</strong>
			                                    </span>
			                                @enderror
				                        </span>
					                    
					                    <div class="fileupload-preview fileupload-exists thumbnail col-4 my-auto bg-theme02"></div>
				                      </div>
				                        
				                        
				                    </div>
				      
				                  </div>
				                </div>
	                        </div>
	                        <div class="form-group">
	                            <div class="col-lg-offset-2 col-lg-10">
	                              <button class="btn btn-theme" type="submit">Guardar</button>
	                              <button class="btn btn-theme04" type="reset">Cancel</button>
	                            </div>
	                          </div>
                        </form>
                                         
                      <!-- /col-lg-8 -->
                    </div>
                    <!-- /row -->
                  </div>
                  <!-- /tab-pane -->
                </div>
                <!-- /tab-content -->
              </div>
              <!-- /panel-body -->
            </div>
            <!-- /col-lg-12 -->
          </div>

    </section>
</section>



@endsection

@section('footer')
 <script  src="{{asset('lib/bootstrap-fileupload/bootstrap-fileupload.js')}}"></script>


@endsection

resources/views/admin/pages/production/index.blade.php
@extends('admin.layouts.app')

@section('title','Centros de Producciones ')

@section('header')


@endsection
@section('production')
active
@endsection
@section('content')
	<section id="main-content">
      <section class="wrapper">
        <!-- page start-->
        <div class="row mt">
          <div class="col-sm-3">
            <section class="panel">
              <div class="panel-body">
                <a href="{{ route('admin.production.create') }}" class="btn btn-compose text-truncate">
                  <i class="fa fa-pencil"></i>  Agregar Centro
                  </a>
                <ul class="nav nav-pills nav-stacked mail-nav row">
                  <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> Activos
                  		<span class="label label-theme pull-right inbox-notification">3</span>
                  	</a>
                  </li>
                  <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> Bloqueados
                  		<span class="label label-info pull-right inbox-notification">8</span>
                  	</a>
                  </li>
                  <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> Eliminados
                  		<span class="label label-theme pull-right inbox-notification">3</span>
                  	</a>
                  </li>
                </ul>
              </div>
            </section>
          </div>
          <div class="col-sm-9">
            <section class="panel">
              <header class="panel-heading wht-bg">
                <h4 class="gen-case">
                    Lista de Centros de producción
                    <form action="#" class="pull-right mail-src-position">
                      <div class="input-append">
                        <input type="text" class="form-control " placeholder="Search Mail">
                      </div>
                    </form>
                  </h4>
              </header>
              <div class="panel-body minimal">
         
                <div class="table-inbox-wrap ">
                  <table class="table table-inbox table-hover">
                    <tbody>
                    	@foreach($productions as $production)
            						<tr class="">
            							<td class="inbox-small-cells">
            								<input type="checkbox" class="mail-checkbox">
            							</td>
            							<td class="view-message  dont-show"><a href="{{ route('admin.production.show', $production) }}">{{ $production->code}}</a></td>
            							<td class="view-message "><a href="{{ route('admin.production.show', $production) }}">{{ $production->name }}</a></td>
            							<td class="view-message ">
            								<a href="{{ route('admin.production.show', $production) }}">
            			                    	@if($production->status===0 )
            			                    		<i class="fa fa-lock"></i> eliminado
            			                    	@elseif($production->status==1)
            			                    		<i class="fa fa-unlock"></i> activo
            			                    	@else
            										<i class="fa fa-unlock"></i> Bloqueado
            			                    	@endif	
            								</a>
            							</td>
            							<td class="view-message  text-right">
            								<a href="{{ route('admin.production.edit', $production) }}" class="px-3"><i class="fa fa-pencil"></i></a>
            								<a href="{{ route('admin.production.update', $production->id) }}" class="px-3"><i class="fa fa-trash-o"></i></a>
            							</td>
            						</tr>
            						@endforeach
                    </tbody>
                  </table>
                </div>
              </div>
            </section>
          </div>
        </div>
      </section>
      <!-- /wrapper -->
    </section>

	
@endsection

@section('footer')


@endsection

resources/views/admin/pages/production/show.blade.php
@extends('admin.layouts.app')

@section('title',$production->name)

@section('header')


@endsection
@section('production')
active
@endsection
@section('content')
<section id="main-content">
      <section class="wrapper site-min-height">
      	<div class="row mt">


      		<div class="col-lg-4 col-md-12 col-12">
                <!-- WHITE PANEL - TOP USER -->
                <div class="panel ">
                  <div class=" chat-room-head panel w-100">
                    <h4 class="text-center">CENTRO DE PRODUCCIÓN {{ $production->name}}</h4>
                  </div>
                  <p class="text-center"><img src="{{ Storage::url($production->src) }}" class="img-circle " width="150"></p>
                  <div class="row">
                    <div class="col-12 row">
                      <p class=" col-4 text-right">CÓDIGO</p>
                      <p class="col-8 text-left">{{ $production->code }}</p>
                    </div>
                    <div class="col-12 row">
                      <p class=" col-4 text-right">CORREO</p>
                      <p class="col-8 text-left">{{ $production->email }}</p>
                    </div>
                    <div class="col-12 row">
                      <p class=" col-4 text-right">TELÉFONO</p>
                      <p class="col-8 text-left">{{ $production->phone }}</p>
                    </div>
                    <div class="col-12 row">
                      <p class=" col-4 text-right">ESTADO</p>
                      <p class="col-8 text-left ">
                      	@if($production->status===0)
                      		Eliminado
                      	@elseif($production->status===1)
                      		Activo
                      	@else
                      		Bloqueado
                      	@endif
                      </p>
                    </div>
                    <div class="col-12 row">
                      <p class=" col-4 text-right">DESCRIPCIÓN</p>
                      <p class="col-8 text-left">{{ $production->description }}</p>
                    </div>
                    <div class="col-12 row">
                      <p class=" col-4 text-right">CREADO</p>
                      <p class="col-8 text-left">{{ $production->created_at }}</p>
                    </div>

                  </div>
                  <div class="panel-body row justify-content-center">
                  	@if($production->id!==1 and $production->status===1)
              		<a href="{{ route('admin.production.edit', $production) }}" class="btn btn-theme02 text-truncate col-5 mx-2">
                  		<i class="fa fa-pencil"></i>  Editar</a>

                  	<form method="Post" action="{{ route('admin.production.destroy', $production) }}" class="w-50" >
						@csrf
					    {{ method_field('DELETE') }}
						<button type="submit" class="btn btn-danger">Bloquear</button>
					</form>
                  	
                	@elseif($production->id==1)
              		<a href="{{ route('admin.production.edit', $production) }}" class="btn btn-theme02 text-truncate col-5 mx-2">
                  		<i class="fa fa-pencil"></i>  Editar</a>
                	@else
					<a class="btn btn-theme01 col-5 mx-2"  href="{{ route('admin.production.update_all',$production) }}" >Activar</a>		
					
					@endif

              	  </div>
                </div>
              </div>

              <div class="col-lg-8 col-md-12 col-12">
	            <section class="panel">
	              <header class="panel-heading wht-bg">
	                <h4 class="gen-case">
	                    Lista de usuarios
	                    <form action="#" class="pull-right mail-src-position">
	                      <div class="input-append">
	                        <input type="text" class="form-control " placeholder="Search Mail">
	                      </div>
	                    </form>
	                  </h4>
	              </header>
	              <div class="panel-body minimal">
	         
	                <div class="table-inbox-wrap ">
	                  <table class="table table-inbox table-hover">
	                    <tbody>
	                    	@foreach($users as $user)
							<tr class="">
								<td class="inbox-small-cells">
									<input type="checkbox" class="mail-checkbox">
								</td>
								<td class="view-message  dont-show"><a href="{{ route('admin.user.show', $user) }}">{{ $user->surname.' '.$user->name}}</a></td>
								<td class="view-message ">
									<a href="{{ route('admin.user.show', $user) }}">
				                    	@if($user->status===0 )
				                    		<i class="fa fa-lock"></i> eliminado
				                    	@elseif($user->status==1)
				                    		<i class="fa fa-unlock"></i> activo
				                    	@else
											<i class="fa fa-unlock"></i> Bloqueado
				                    	@endif	
									</a>
								</td>
								<td class="view-message  text-right">
									<a href="{{ route('admin.user.edit', $user) }}" class="px-3"><i class="fa fa-pencil"></i></a>
									<a href="{{ route('admin.user.update', $user->id) }}" class="px-3"><i class="fa fa-trash-o"></i></a>
								</td>
							</tr>
							@endforeach
	                    </tbody>
	                  </table>
	                </div>
	              </div>
	            </section>
	          </div>

        </div>
    </section>


</section>


	
	<form method="Post" action="{{ route('admin.production.update', $production) }}" name="active">
		@csrf
	    {{ method_field('PUT') }}
	</form>
	
	
	
@endsection

@section('footer')


@endsection